namespace PolClient
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using PageBoxGrid;

	/// <p>User control controlling the login</p>
	/// <p>Copyright (c) 2002 Alexis Grandemange<br/>
	/// Mail: alexis.grandemange@pagebox.net</p>
	/// <pre>This program is free software; you can redistribute it and/or
	/// modify it under the terms of the GNU Lesser General Public
	/// License as published by the Free Software Foundation; version
	/// 2.1 of the License.
	/// This library is distributed in the hope that it will be useful,
	/// but WITHOUT ANY WARRANTY; without even the implied warranty of
	/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	/// GNU Lesser General Public License for more details.
	/// A copy of the GNU Lesser General Public License lesser.txt should be
	/// included in the distribution.</pre>
	public abstract class PolLogin : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.Label lblUser;
		protected System.Web.UI.WebControls.TextBox User;
		protected System.Web.UI.WebControls.Label lblPassword;
		protected System.Web.UI.WebControls.TextBox Password;
		protected System.Web.UI.WebControls.Label labStatus;
		protected System.Web.UI.WebControls.Button ButLogin;
		protected System.Web.UI.WebControls.Panel LoginPanel;


		/// <summary>
		/// CSS class to use for the status
		/// </summary>
		private string statusCss = null;
		public string StatusCss 
		{
			get { return statusCss; }
			set { statusCss = value; }
		}
		/// <summary>
		/// Table width (when the Datagrid is not displayed)
		/// </summary>
		private string width = null;
		public string Width 
		{
			get { return width; }
			set { width = value; }
		}
		/// <summary>
		/// CSS class to use for the embedding panel
		/// </summary>
		private string css = null;
	
		public string Css 
		{
			get { return css; }
			set { css = value; }
		}

		/// <summary>
		public PolLogin()
		{
			this.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack) 
			{
				if (statusCss != null)
					labStatus.CssClass = statusCss;
				if (css != null)
					LoginPanel.CssClass = css;
				if (width != null)
					LoginPanel.Width = Unit.Pixel(Convert.ToInt16(width));
			}
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ButLogin.Click += new System.EventHandler(this.OnLogin);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		/// <summary>
		/// Called when the user clicks on the Login button.
		/// Adds the user name to heap.
		/// A real login control would check the user credentials.
		/// </summary>
		private void OnLogin(object sender, System.EventArgs e)
		{
			if ((User.Text.Length == 0) || (Password.Text.Length == 0))
				labStatus.Text = "Enter your user name and password";
			else 
			{
				labStatus.Text = "";
				PageBoxGrid.Heap.Put(ID, Session.SessionID, User.Text);
			}
		}
	}
}
